/*
 * Common panel server functionality.
 *
 * (c) 2018 Paul Boddie <paul@boddie.org.uk>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA  02110-1301, USA
 */

#pragma once

#ifdef __cplusplus

#include <l4/cxx/ipc_server>
#include <l4/re/dataspace>
#include <l4/re/env>

/* Server object to provide panel data access. */

class Panel_server : public L4::Server_object_t<L4::Kobject>
{
private:
  void *_panel;
  unsigned long _size;

public:
  /* Initialise the server with an opaque pointer to the panel data and the
     size of the data. */

  explicit Panel_server(void *panel, unsigned long size)
  : _panel(panel), _size(size)
  {}

  int dispatch(l4_umword_t obj, L4::Ipc::Iostream &ios);
};

#endif
